// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/18AISS8AO8/18AISS8AO8_1.x_GSC_DN/driver/18aiss8ao8.h $
// $Rev: 51963 $
// $Date: 2022-10-26 10:20:45 -0500 (Wed, 26 Oct 2022) $

// 18AISS8AO8: Device Driver: header file

#ifndef	__18AISS8AO8_H__
#define	__18AISS8AO8_H__

#include "gsc_common.h"
#include "gsc_pci9056.h"



// macros *********************************************************************

#define	AISS8AO8_BASE_NAME					"18aiss8ao8"

// IOCTL command codes
#define	AISS8AO8_IOCTL_REG_READ				OS_IOCTL_RW( 0, 12, gsc_reg_t)
#define	AISS8AO8_IOCTL_REG_WRITE			OS_IOCTL_W ( 1, 12, gsc_reg_t)
#define	AISS8AO8_IOCTL_REG_MOD				OS_IOCTL_W ( 2, 12, gsc_reg_t)
#define	AISS8AO8_IOCTL_QUERY				OS_IOCTL_RW( 3,  4, s32)
#define	AISS8AO8_IOCTL_INITIALIZE			OS_IOCTL   ( 4)
#define	AISS8AO8_IOCTL_AUTO_CALIBRATE		OS_IOCTL   ( 5)
#define	AISS8AO8_IOCTL_AUTO_CAL_STS			OS_IOCTL_R ( 6,  4, s32)
#define	AISS8AO8_IOCTL_AI_BUF_CLEAR			OS_IOCTL   ( 7)
#define	AISS8AO8_IOCTL_AI_BUF_LEVEL			OS_IOCTL_R ( 8,  4, s32)
#define	AISS8AO8_IOCTL_AI_BUF_OVERFLOW		OS_IOCTL_RW( 9,  4, s32)
#define	AISS8AO8_IOCTL_AI_BUF_THR_LVL		OS_IOCTL_RW(10,  4, s32)
#define	AISS8AO8_IOCTL_AI_BUF_THR_STS		OS_IOCTL_RW(11,  4, s32)
#define	AISS8AO8_IOCTL_AI_BURST_ENABLE		OS_IOCTL_RW(12,  4, s32)
#define	AISS8AO8_IOCTL_AI_BURST_SIZE		OS_IOCTL_RW(13,  4, s32)
#define	AISS8AO8_IOCTL_AI_BURST_STATUS		OS_IOCTL_R (14,  4, s32)
#define	AISS8AO8_IOCTL_AI_CHAN_SEL			OS_IOCTL_RW(15,  4, s32)
#define	AISS8AO8_IOCTL_AI_CLK_TRIG_OUT		OS_IOCTL_RW(16,  4, s32)
#define	AISS8AO8_IOCTL_AI_CLOCK_SRC			OS_IOCTL_RW(17,  4, s32)
#define	AISS8AO8_IOCTL_AI_ENABLE			OS_IOCTL_RW(18,  4, s32)
#define	AISS8AO8_IOCTL_AI_GRP_A_FILTER		OS_IOCTL_RW(19,  4, s32)
#define	AISS8AO8_IOCTL_AI_GRP_B_FILTER		OS_IOCTL_RW(20,  4, s32)
#define	AISS8AO8_IOCTL_AI_I_LOOP_TERM		OS_IOCTL_RW(21,  4, s32)
#define	AISS8AO8_IOCTL_AI_MODE				OS_IOCTL_RW(22,  4, s32)
#define	AISS8AO8_IOCTL_AI_RANGE				OS_IOCTL_RW(23,  4, s32)
#define	AISS8AO8_IOCTL_AI_SW_CLOCK			OS_IOCTL   (24)
#define	AISS8AO8_IOCTL_AI_SW_TRIGGER		OS_IOCTL   (25)
#define	AISS8AO8_IOCTL_AI_TRIG_SRC			OS_IOCTL_RW(26,  4, s32)
#define	AISS8AO8_IOCTL_AO_BUF_CLEAR			OS_IOCTL   (27)
#define	AISS8AO8_IOCTL_AO_BUF_EMPTY			OS_IOCTL_R (28,  4, s32)
#define	AISS8AO8_IOCTL_AO_BUF_FULL			OS_IOCTL_R (29,  4, s32)
#define	AISS8AO8_IOCTL_AO_BUF_LEVEL			OS_IOCTL_R (30,  4, s32)
#define	AISS8AO8_IOCTL_AO_BUF_LOAD_REQ		OS_IOCTL   (31)
#define	AISS8AO8_IOCTL_AO_BUF_LOAD_STS		OS_IOCTL_R (32,  4, s32)
#define	AISS8AO8_IOCTL_AO_BUF_MODE			OS_IOCTL_RW(33,  4, s32)
#define	AISS8AO8_IOCTL_AO_BUF_OVER_DATA		OS_IOCTL_RW(34,  4, s32)
#define	AISS8AO8_IOCTL_AO_BUF_OVER_FRAM		OS_IOCTL_RW(35,  4, s32)
#define	AISS8AO8_IOCTL_AO_BUF_THR_LVL		OS_IOCTL_RW(36,  4, s32)
#define	AISS8AO8_IOCTL_AO_BUF_THR_STS		OS_IOCTL_R (37,  4, s32)
#define	AISS8AO8_IOCTL_AO_BURST_ENABLE		OS_IOCTL_RW(38,  4, s32)
#define	AISS8AO8_IOCTL_AO_BURST_STATUS		OS_IOCTL_R (39,  4, s32)
#define	AISS8AO8_IOCTL_AO_CHAN_SEL			OS_IOCTL_RW(40,  4, s32)
#define	AISS8AO8_IOCTL_AO_CLK_TRIG_OUT		OS_IOCTL_RW(41,  4, s32)
#define	AISS8AO8_IOCTL_AO_CLOCK_READY		OS_IOCTL_R (42,  4, s32)
#define	AISS8AO8_IOCTL_AO_CLOCK_SRC			OS_IOCTL_RW(43,  4, s32)
#define	AISS8AO8_IOCTL_AO_ENABLE			OS_IOCTL_RW(44,  4, s32)
#define	AISS8AO8_IOCTL_AO_MODE				OS_IOCTL_RW(45,  4, s32)
#define	AISS8AO8_IOCTL_AO_OUTPUT_MODE		OS_IOCTL_RW(46,  4, s32)
#define	AISS8AO8_IOCTL_AO_RANGE				OS_IOCTL_RW(47,  4, s32)
#define	AISS8AO8_IOCTL_AO_SW_CLOCK			OS_IOCTL   (48)
#define	AISS8AO8_IOCTL_AO_SW_TRIGGER		OS_IOCTL   (49)
#define	AISS8AO8_IOCTL_AO_TRIG_SRC			OS_IOCTL_RW(50,  4, s32)
#define	AISS8AO8_IOCTL_DATA_FORMAT			OS_IOCTL_RW(51,  4, s32)
#define	AISS8AO8_IOCTL_DIO_DIR_OUT			OS_IOCTL_RW(52,  4, s32)
#define	AISS8AO8_IOCTL_DIO_READ				OS_IOCTL_R (53,  4, s32)
#define	AISS8AO8_IOCTL_DIO_WRITE			OS_IOCTL_RW(54,  4, s32)
#define	AISS8AO8_IOCTL_GEN_A_ENABLE			OS_IOCTL_RW(55,  4, s32)
#define	AISS8AO8_IOCTL_GEN_A_NDIV			OS_IOCTL_RW(56,  4, s32)
#define	AISS8AO8_IOCTL_GEN_B_ENABLE			OS_IOCTL_RW(57,  4, s32)
#define	AISS8AO8_IOCTL_GEN_B_NDIV			OS_IOCTL_RW(58,  4, s32)
#define	AISS8AO8_IOCTL_GEN_C_ENABLE			OS_IOCTL_RW(59,  4, s32)
#define	AISS8AO8_IOCTL_GEN_C_NDIV			OS_IOCTL_RW(60,  4, s32)
#define	AISS8AO8_IOCTL_GEN_D_ENABLE			OS_IOCTL_RW(61,  4, s32)
#define	AISS8AO8_IOCTL_GEN_D_NDIV			OS_IOCTL_RW(62,  4, s32)
#define	AISS8AO8_IOCTL_IRQ_ENABLE			OS_IOCTL_RW(63,  4, s32)
#define	AISS8AO8_IOCTL_RX_IO_ABORT			OS_IOCTL_R (64,  4, s32)
#define	AISS8AO8_IOCTL_RX_IO_MODE			OS_IOCTL_RW(65,  4, s32)
#define	AISS8AO8_IOCTL_RX_IO_OVERFLOW		OS_IOCTL_RW(66,  4, s32)
#define	AISS8AO8_IOCTL_RX_IO_TIMEOUT		OS_IOCTL_RW(67,  4, s32)
#define	AISS8AO8_IOCTL_TX_IO_ABORT			OS_IOCTL_R (68,  4, s32)
#define	AISS8AO8_IOCTL_TX_IO_MODE			OS_IOCTL_RW(69,  4, s32)
#define	AISS8AO8_IOCTL_TX_IO_OVERFLOW		OS_IOCTL_RW(70,  4, s32)
#define	AISS8AO8_IOCTL_TX_IO_TIMEOUT		OS_IOCTL_RW(71,  4, s32)
#define	AISS8AO8_IOCTL_WAIT_CANCEL			OS_IOCTL_RW(72, 28, gsc_wait_t)
#define	AISS8AO8_IOCTL_WAIT_EVENT			OS_IOCTL_RW(73, 28, gsc_wait_t)
#define	AISS8AO8_IOCTL_WAIT_STATUS			OS_IOCTL_RW(74, 28, gsc_wait_t)
#define	AISS8AO8_IOCTL_WARP_MODE			OS_IOCTL_RW(75,  4, s32)
#define	AISS8AO8_IOCTL_RX_IO_UNDERFLOW		OS_IOCTL_RW(76,  4, s32)
#define	AISS8AO8_IOCTL_AI_BUF_UNDERFLOW		OS_IOCTL_RW(77,  4, s32)

// AISS8AO8_IOCTL_REG_READ
// AISS8AO8_IOCTL_REG_WRITE
// AISS8AO8_IOCTL_REG_MOD
//
#define	AISS8AO8_REG_ENCODE(s,o)			GSC_REG_ENCODE(GSC_REG_TYPE_BAR2,(s),(o))
// Parameter:	gsc_reg_t*
#define	AISS8AO8_GSC_BCR					AISS8AO8_REG_ENCODE(4,0x00)// Board Control Register
#define	AISS8AO8_GSC_DIOPR					AISS8AO8_REG_ENCODE(4,0x04)// Digital I/O Port Register
#define	AISS8AO8_GSC_CLSR					AISS8AO8_REG_ENCODE(4,0x0C)// Current Loop Selection Register
#define	AISS8AO8_GSC_ICR					AISS8AO8_REG_ENCODE(4,0x14)// Input Configuration Register
#define	AISS8AO8_GSC_IBDR					AISS8AO8_REG_ENCODE(4,0x18)// Input Buffer Data Register
#define	AISS8AO8_GSC_RAGR					AISS8AO8_REG_ENCODE(4,0x1C)// Rate-A Generator Register
#define	AISS8AO8_GSC_RBGR					AISS8AO8_REG_ENCODE(4,0x20)// Rate-B Generator Register
#define	AISS8AO8_GSC_IBBSR					AISS8AO8_REG_ENCODE(4,0x24)// Input Burst Block Size Register
#define	AISS8AO8_GSC_IBSR					AISS8AO8_REG_ENCODE(4,0x28)// Input Buffer Size Register
#define	AISS8AO8_GSC_IBTR					AISS8AO8_REG_ENCODE(4,0x2C)// Input Buffer Threshold Register
#define	AISS8AO8_GSC_PSR					AISS8AO8_REG_ENCODE(4,0x30)// Primary Status Register
#define	AISS8AO8_GSC_ACR					AISS8AO8_REG_ENCODE(4,0x34)// Assembly Configuration Register
#define	AISS8AO8_GSC_AVR					AISS8AO8_REG_ENCODE(4,0x38)// Autocal Values Register
#define	AISS8AO8_GSC_BOOR					AISS8AO8_REG_ENCODE(4,0x3C)// Buffered Output Operations Register
#define	AISS8AO8_GSC_OBTR					AISS8AO8_REG_ENCODE(4,0x40)// Output Buffer Threshold Register
#define	AISS8AO8_GSC_OBSR					AISS8AO8_REG_ENCODE(4,0x44)// Output Buffer Size Register
#define	AISS8AO8_GSC_OBDR					AISS8AO8_REG_ENCODE(4,0x48)// Output Buffer Data Register
#define	AISS8AO8_GSC_RCGR					AISS8AO8_REG_ENCODE(4,0x4C)// Rate-C Generator Register
#define	AISS8AO8_GSC_RDGR					AISS8AO8_REG_ENCODE(4,0x50)// Rate-D Generator Register
#define	AISS8AO8_GSC_OCR					AISS8AO8_REG_ENCODE(4,0x54)// Output Configuration Register

//*****************************************************************************
// AISS8AO8_IOCTL_QUERY
//
//	Parameter:	s32
//		Pass in a value from the list below.
//		The value returned is the answer to the query.

typedef enum
{
	AISS8AO8_QUERY_AUTO_CAL_MS,			// Max auto-cal period in ms.
	AISS8AO8_QUERY_CHANNEL_AI_MAX,		// Maximum number of input channels supported.
	AISS8AO8_QUERY_CHANNEL_AI_QTY,		// The number of input channels supported.
	AISS8AO8_QUERY_CHANNEL_AO_MAX,		// Maximum number of output channels supported.
	AISS8AO8_QUERY_CHANNEL_AO_QTY,		// The number of output channels supported.
	AISS8AO8_QUERY_COUNT,				// How many query options are supported?
	AISS8AO8_QUERY_DEVICE_TYPE,			// Value from gsc_dev_type_t
	AISS8AO8_QUERY_FIFO_SIZE_RX,		// Rx FIFO depth in 32-bit samples
	AISS8AO8_QUERY_FIFO_SIZE_TX,		// Tx FIFO depth in 32-bit samples
	AISS8AO8_QUERY_FILTER_A,			// Filter A Frequency
	AISS8AO8_QUERY_FILTER_B,			// Filter B Frequency
	AISS8AO8_QUERY_FSAMP_MAX,			// The maximum sample rate per channel.
	AISS8AO8_QUERY_FSAMP_MIN,			// The minimum sample rate per channel.
	AISS8AO8_QUERY_INIT_MS,				// Max initialize period in ms.
	AISS8AO8_QUERY_MASTER_CLOCK,		// Master clock frequency
	AISS8AO8_QUERY_NDIV_MAX,			// The maximum usable Ndiv value.
	AISS8AO8_QUERY_NDIV_MIN,			// The minimum usable Ndiv value.
	AISS8AO8_QUERY_AI_UNDERFLOW,		// Does the firmware support AI buffer underflow?
	AISS8AO8_QUERY_DMDMA,				// Does the firmware support Demand Mode DMA?

	AISS8AO8_IOCTL_QUERY_LAST

} aiss8ao8_query_t;

#define	AISS8AO8_IOCTL_QUERY_ERROR			(-1)

//*****************************************************************************
// AISS8AO8_IOCTL_INITIALIZE				BCR D31
//
//	Parameter:	None

//*****************************************************************************
// AISS8AO8_IOCTL_AUTO_CALIBRATE			BCR D28
//
//	Parameter:	None

//*****************************************************************************
// AISS8AO8_IOCTL_AUTO_CAL_STS				BCR D29, D28
//
//	Parameter:	s32*
//		One of the below values is returned.
#define	AISS8AO8_AUTO_CAL_STS_ACTIVE		0
#define	AISS8AO8_AUTO_CAL_STS_FAIL			1
#define	AISS8AO8_AUTO_CAL_STS_PASS			2

//*****************************************************************************
// AISS8AO8_IOCTL_AI_BUF_CLEAR				BCR D13
// AISS8AO8_IOCTL_AO_BUF_CLEAR				BOOR D11
//
//	Parameter:	None.

//*****************************************************************************
// AISS8AO8_IOCTL_AI_BUF_LEVEL				IBSR D0-D19
// AISS8AO8_IOCTL_AO_BUF_LEVEL				OBSR D0-D19
//
//	Parameter:	s32*
//		The value returned is the current buffer fill level.

//*****************************************************************************
// AISS8AO8_IOCTL_AI_BUF_OVERFLOW			BCR D15
// AISS8AO8_IOCTL_AO_BUF_OVER_DATA			BOOR D16
// AISS8AO8_IOCTL_AO_BUF_OVER_FRAM			BOOR D17
//
//	Parameter:	s32*
//		Pass in any valid option below, or
//		-1 to read the current setting.
#define	AISS8AO8_BUF_OVERFLOW_CLEAR			0
#define	AISS8AO8_BUF_OVERFLOW_TEST			(-1)

// For queries the following values are returned.
#define	AISS8AO8_BUF_OVERFLOW_NO			0
#define	AISS8AO8_BUF_OVERFLOW_YES			1

//*****************************************************************************
// AISS8AO8_IOCTL_AI_BUF_THR_LVL			IBTR D0-D19
// AISS8AO8_IOCTL_AO_BUF_THR_LVL			OBTR D0-D19
//
//	Parameter:	s32*
//		Pass in any valid value from 0x0 to 0xFFFFF, or
//		-1 to read the current setting.

//*****************************************************************************
// AISS8AO8_IOCTL_AI_BUF_THR_STS			BCR D14, IBTR D20
// AISS8AO8_IOCTL_AO_BUF_THR_STS			BOOR D13, OBTR D20
//
//	Parameter:	s32*
//		The value returned is one of the following.
#define	AISS8AO8_BUF_THR_STS_CLEAR			0
#define	AISS8AO8_BUF_THR_STS_SET			1

//*****************************************************************************
// AISS8AO8_IOCTL_AI_BURST_ENABLE			BCR D9
// AISS8AO8_IOCTL_AO_BURST_ENABLE			BOOR D19
//
//	Parameter:	s32*
//		The value returned is one of the following.
#define	AISS8AO8_BURST_ENABLE_NO			0
#define	AISS8AO8_BURST_ENABLE_YES			1

//*****************************************************************************
// AISS8AO8_IOCTL_AI_BURST_SIZE				IBBSR D0-D23
//
//	Parameter:	s32*
//		Pass in any value between the below inclusive limits, or
//		-1 to read the current setting.
//		At this time the valid range is 0-0xFFFFFF.

//*****************************************************************************
// AISS8AO8_IOCTL_AI_BURST_STATUS			BCR D10
//
//	Parameter:	s32*
//		The value returned is one of the following.
#define	AISS8AO8_AI_BURST_STATUS_READY		0
#define	AISS8AO8_AI_BURST_STATUS_BUSY		1

//*****************************************************************************
// AISS8AO8_IOCTL_AI_CHAN_SEL				ICR D0-D7
// AISS8AO8_IOCTL_AO_CHAN_SEL				OCR D0-D7
//
//	Parameter:	s32*
//		Pass in a bitmap of the channels to enable, or
//		-1 to read the current setting.
//		A valid bitmap is dependent on the AI or AO selection and the
//		number of corresponding input or output channels on the device.

//*****************************************************************************
// AISS8AO8_IOCTL_AI_CLK_TRIG_OUT			ICR D11
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AISS8AO8_AI_CLK_TRIG_OUT_OFF		0
#define	AISS8AO8_AI_CLK_TRIG_OUT_DRIVE		1

//*****************************************************************************
// AISS8AO8_IOCTL_AI_CLOCK_SRC				ICR D12-D13
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AISS8AO8_AI_CLOCK_SRC_RAG			0
#define	AISS8AO8_AI_CLOCK_SRC_RCG			1
#define	AISS8AO8_AI_CLOCK_SRC_EXT			2

//*****************************************************************************
// AISS8AO8_IOCTL_AI_ENABLE					BCR D12
// AISS8AO8_IOCTL_AO_ENABLE					BOOR D5
//
//	Parameter:	s32*
//		Pass in any valid option below, or
//		-1 to read the current setting.
#define	AISS8AO8_AIO_ENABLE_NO				0	// Disable the buffer.
#define	AISS8AO8_AIO_ENABLE_YES				1	// Enable the buffer.

//*****************************************************************************
// AISS8AO8_IOCTL_AI_GRP_A_FILTER			ICR D24-D25
// AISS8AO8_IOCTL_AI_GRP_B_FILTER			ICR D26-D27
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AISS8AO8_AI_GRP_FILTER_NONE			0
#define	AISS8AO8_AI_GRP_FILTER_A			1
#define	AISS8AO8_AI_GRP_FILTER_B			2

//*****************************************************************************
// AISS8AO8_IOCTL_AI_I_LOOP_TERM			CLSR D0-D7
//
//	Parameter:	s32*
//		Pass in any value in the range of 0 to 0xFF, or
//		-1 to read the current setting.

//*****************************************************************************
// AISS8AO8_IOCTL_AI_MODE					ICR D16-D20
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AISS8AO8_AI_MODE_DIFF				0	// Differential
#define	AISS8AO8_AI_MODE_SINGLE				1	// Single-Ended
#define	AISS8AO8_AI_MODE_ZERO				2	// Zero test
#define	AISS8AO8_AI_MODE_VREF				3	// Vref test
#define	AISS8AO8_AI_MODE_AO_0_HI			16	// Analog Output Channel 0 High
#define	AISS8AO8_AI_MODE_AO_1_HI			17	// Analog Output Channel 1 High
#define	AISS8AO8_AI_MODE_AO_2_HI			18	// Analog Output Channel 2 High
#define	AISS8AO8_AI_MODE_AO_3_HI			19	// Analog Output Channel 3 High
#define	AISS8AO8_AI_MODE_AO_4_HI			20	// Analog Output Channel 5 High
#define	AISS8AO8_AI_MODE_AO_5_HI			21	// Analog Output Channel 6 High
#define	AISS8AO8_AI_MODE_AO_6_HI			22	// Analog Output Channel 7 High
#define	AISS8AO8_AI_MODE_AO_7_HI			23	// Analog Output Channel 3 High
#define	AISS8AO8_AI_MODE_AO_0_LO			24	// Analog Output Channel 0 Low
#define	AISS8AO8_AI_MODE_AO_1_LO			25	// Analog Output Channel 1 Low
#define	AISS8AO8_AI_MODE_AO_2_LO			26	// Analog Output Channel 2 Low
#define	AISS8AO8_AI_MODE_AO_3_LO			27	// Analog Output Channel 3 Low
#define	AISS8AO8_AI_MODE_AO_4_LO			28	// Analog Output Channel 4 Low
#define	AISS8AO8_AI_MODE_AO_5_LO			29	// Analog Output Channel 5 Low
#define	AISS8AO8_AI_MODE_AO_6_LO			30	// Analog Output Channel 6 Low
#define	AISS8AO8_AI_MODE_AO_7_LO			31	// Analog Output Channel 7 Low

//*****************************************************************************
// AISS8AO8_IOCTL_AI_RANGE					ICR D8-D10
// AISS8AO8_IOCTL_AO_RANGE					OCR D8-D10
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AISS8AO8_RANGE_2_5V					0	// +- 2.5 volts
#define	AISS8AO8_RANGE_5V					1	// +- 5 volts
#define	AISS8AO8_RANGE_10V					2	// +- 10 volts
#define	AISS8AO8_RANGE_0_5V					3	// 0 to 5 volts
#define	AISS8AO8_RANGE_0_10V				4	// 0 to 10 volts

//*****************************************************************************
// AISS8AO8_IOCTL_AI_SW_CLOCK				BCR D8
// AISS8AO8_IOCTL_AO_SW_CLOCK				BCR D20, BOOR D7
//
//	Parameter:	None.

//*****************************************************************************
// AISS8AO8_IOCTL_AI_SW_TRIGGER				BCR D11
// AISS8AO8_IOCTL_AO_SW_TRIGGER				BCR D23, BOOR D20
//
//	Parameter:	None.

//*****************************************************************************
// AISS8AO8_IOCTL_AI_TRIG_SRC				ICR D14-D15
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AISS8AO8_AI_TRIG_SRC_RBG			0
#define	AISS8AO8_AI_TRIG_SRC_RDG			1
#define	AISS8AO8_AI_TRIG_SRC_EXT			2

//*****************************************************************************
// AISS8AO8_IOCTL_AO_BUF_EMPTY				BOOR D12
//
//	Parameter:	s32*
//		The value returned is one of the following.
#define	AISS8AO8_AO_BUFFER_EMPTY_NO			0
#define	AISS8AO8_AO_BUFFER_EMPTY_YES		1

//*****************************************************************************
// AISS8AO8_IOCTL_AO_BUF_FULL				BOOR D15
//
//	Parameter:	s32*
//		The value returned is one of the following.
#define	AISS8AO8_AO_BUFFER_FULL_NO			0
#define	AISS8AO8_AO_BUFFER_FULL_YES			1

//*****************************************************************************
// AISS8AO8_IOCTL_AO_BUF_LOAD_REQ			BOOR D9
//
//	Parameter:	None.

//*****************************************************************************
// AISS8AO8_IOCTL_AO_BUF_LOAD_STS			BOOR D10
//
//	Parameter:	s32*
//		The value returned is one of the following.
#define	AISS8AO8_BUF_LOAD_STS_NOT_READY		0
#define	AISS8AO8_BUF_LOAD_STS_READY			1

//*****************************************************************************
// AISS8AO8_IOCTL_AO_BUF_MODE				BOOR D8
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AISS8AO8_BUF_MODE_OPEN				0
#define	AISS8AO8_BUF_MODE_CIRC				1

//*****************************************************************************
// AISS8AO8_IOCTL_AO_BURST_STATUS			BOOR D18
//
//	Parameter:	s32*
//		The value returned is one of the following.
#define	AISS8AO8_AO_BURST_STATUS_BUSY		0
#define	AISS8AO8_AO_BURST_STATUS_READY		1

//*****************************************************************************
// AISS8AO8_IOCTL_AO_CLK_TRIG_OUT			OCR D11
//
//	Parameter:	s32*
//		The value returned is one of the following.
#define	AISS8AO8_AO_CLK_TRIG_OUT_OFF		0
#define	AISS8AO8_AO_CLK_TRIG_OUT_DRIVE		1

//*****************************************************************************
// AISS8AO8_IOCTL_AO_CLOCK_READY			BOOR D6
//
//	Parameter:	s32*
//		The value returned is one of the following.
#define	AISS8AO8_CLOCK_READY_NO				0
#define	AISS8AO8_CLOCK_READY_YES			1

//*****************************************************************************
// AISS8AO8_IOCTL_AO_CLOCK_SRC				OCR D12-D13
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AISS8AO8_AO_CLOCK_SRC_RCG			0
#define	AISS8AO8_AO_CLOCK_SRC_RAG			1
#define	AISS8AO8_AO_CLOCK_SRC_EXT			2

//*****************************************************************************
// AISS8AO8_IOCTL_AO_MODE					OCR D16
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AISS8AO8_AO_MODE_SINGLE				0	// Single-Ended
#define	AISS8AO8_AO_MODE_DIFF				1	// Differential

//*****************************************************************************
// AISS8AO8_IOCTL_AO_OUTPUT_MODE			BCR D18
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AISS8AO8_AO_OUTPUT_MODE_IMMED		0
#define	AISS8AO8_AO_OUTPUT_MODE_SIMUL		1

//*****************************************************************************
// AISS8AO8_IOCTL_AO_TRIG_SRC				OCR D14-D15
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AISS8AO8_AO_TRIG_SRC_RDG			0
#define	AISS8AO8_AO_TRIG_SRC_RBG			1
#define	AISS8AO8_AO_TRIG_SRC_EXT			2

//*****************************************************************************
// AISS8AO8_IOCTL_DATA_FORMAT				BCR D25
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AISS8AO8_DATA_FORMAT_2S_COMP		0	// Twos Compliment
#define	AISS8AO8_DATA_FORMAT_OFF_BIN		1	// Offset Binary

//*****************************************************************************
// AISS8AO8_IOCTL_DIO_DIR_OUT				DIOPR D7, D15
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AISS8AO8_DIO_DIR_OUT_HI_IN_LO_IN	0  // default state
#define	AISS8AO8_DIO_DIR_OUT_HI_IN_LO_OT	1
#define	AISS8AO8_DIO_DIR_OUT_HI_OT_LO_IN	2
#define	AISS8AO8_DIO_DIR_OUT_HI_OT_LO_OT	3

//*****************************************************************************
// AISS8AO8_IOCTL_DIO_READ					DIOPR D0-D3, D8-D11
//
//	Parameter:	s32*
//		The value returned is in the range of 0 to 0xFF.

//*****************************************************************************
// AISS8AO8_IOCTL_DIO_WRITE					DIOPR D0-D3, D8-D11
//
//	Parameter:	s32*
//		Pass in any value in the range of 0 to 0xFF, or
//		-1 to read the current setting.

//*****************************************************************************
// AISS8AO8_IOCTL_GEN_A_ENABLE				BCR D26
// AISS8AO8_IOCTL_GEN_B_ENABLE				BCR D27
// AISS8AO8_IOCTL_GEN_C_ENABLE				BCR D21
// AISS8AO8_IOCTL_GEN_D_ENABLE				BCR D22
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AISS8AO8_GEN_ENABLE_NO				0
#define	AISS8AO8_GEN_ENABLE_YES				1

//*****************************************************************************
// AISS8AO8_IOCTL_GEN_A_NDIV				RAGR D0-D23
// AISS8AO8_IOCTL_GEN_B_NDIV				RBGR D0-D23
// AISS8AO8_IOCTL_GEN_C_NDIV				RCGR D0-D23
// AISS8AO8_IOCTL_GEN_D_NDIV				RDGR D0-D23
//
//	Parameter:	s32*
//		Pass in any value in the range of 80 to 0xFFFFFF, or
//		-1 to read the current setting.

//*****************************************************************************
// AISS8AO8_IOCTL_IRQ_ENABLE				PSR D0-D14
//
//	Parameter:	s32*
//		Pass in any combination of the below options, or
//		-1 to read the current setting.
#define	AISS8AO8_IRQ_AUTO_CAL_DONE			0x0001
#define	AISS8AO8_IRQ_AI_THRESH_H2L			0x0002
#define	AISS8AO8_IRQ_AI_THRESH_L2H			0x0004
#define	AISS8AO8_IRQ_AI_FAULT				0x0008
#define	AISS8AO8_IRQ_AI_BURST_START			0x0010
#define	AISS8AO8_IRQ_AI_BURST_DONE			0x0020
#define	AISS8AO8_IRQ_AI_CLOCK				0x0040
#define	AISS8AO8_IRQ_AO_CLOCK				0x0080
#define	AISS8AO8_IRQ_DIO_0_L2H				0x0100
#define	AISS8AO8_IRQ_AO_THRESH_H2L			0x0200
#define	AISS8AO8_IRQ_AO_THRESH_L2H			0x0400
#define	AISS8AO8_IRQ_AO_LOAD_RDY_H2L		0x0800
#define	AISS8AO8_IRQ_AO_LOAD_RDY_L2H		0x1000
#define	AISS8AO8_IRQ_AO_BURST_READY			0x2000
#define	AISS8AO8_IRQ_AO_FAULT				0x4000
#define	AISS8AO8_IRQ_ALL					0x7FFF

//*****************************************************************************
// AISS8AO8_IOCTL_RX_IO_ABORT
// AISS8AO8_IOCTL_TX_IO_ABORT
//
//	Parameter:	s32*
//		The returned value is one of the below options.
#define	AISS8AO8_IO_ABORT_NO				0
#define	AISS8AO8_IO_ABORT_YES				1

//*****************************************************************************
// AISS8AO8_IOCTL_RX_IO_MODE
// AISS8AO8_IOCTL_TX_IO_MODE
//
//	Parameter:	s32*
//		Pass in any of the gsc_io_mode_t options, or
//		-1 to read the current setting.
#define	AISS8AO8_IO_MODE_DEFAULT			GSC_IO_MODE_PIO

//*****************************************************************************
// AISS8AO8_IOCTL_RX_IO_OVERFLOW
// AISS8AO8_IOCTL_TX_IO_OVERFLOW
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AISS8AO8_IO_OVERFLOW_DEFAULT		AISS8AO8_IO_OVERFLOW_CHECK
#define	AISS8AO8_IO_OVERFLOW_IGNORE			0
#define	AISS8AO8_IO_OVERFLOW_CHECK			1

//*****************************************************************************
// AISS8AO8_IOCTL_RX_IO_TIMEOUT (in seconds)
// AISS8AO8_IOCTL_TX_IO_TIMEOUT (in seconds)
//
//	Parameter:	s32*
//		Pass in any value from the minimim to the maximim, the infinite option,
//		or -1 to read the current setting. The value -1 is returned if the
//		feature is not supported, but this should never happen.
#define	AISS8AO8_IO_TIMEOUT_DEFAULT			10
#define	AISS8AO8_IO_TIMEOUT_NO_SLEEP		0
#define	AISS8AO8_IO_TIMEOUT_MIN				0
#define	AISS8AO8_IO_TIMEOUT_MAX				GSC_IO_TIMEOUT_MAX
#define	AISS8AO8_IO_TIMEOUT_INFINITE		GSC_IO_TIMEOUT_INFINITE

//*****************************************************************************
// AISS8AO8_IOCTL_WAIT_CANCEL				fields need not be valid
// AISS8AO8_IOCTL_WAIT_EVENT				all fields must be valid
// AISS8AO8_IOCTL_WAIT_STATUS				fields need not be valid
//
//	Parameter:	gsc_wait_t*
// gsc_wait_t.flags - see gsc_common.h
// gsc_wait_t.main - see gsc_common.h
// gsc_wait_t.gsc
#define	AISS8AO8_WAIT_GSC_AUTO_CAL_DONE		AISS8AO8_IRQ_AUTO_CAL_DONE
#define	AISS8AO8_WAIT_GSC_AI_THRESH_H2L		AISS8AO8_IRQ_AI_THRESH_H2L
#define	AISS8AO8_WAIT_GSC_AI_THRESH_L2H		AISS8AO8_IRQ_AI_THRESH_L2H
#define	AISS8AO8_WAIT_GSC_AI_FAULT			AISS8AO8_IRQ_AI_FAULT
#define	AISS8AO8_WAIT_GSC_AI_BURST_START	AISS8AO8_IRQ_AI_BURST_START
#define	AISS8AO8_WAIT_GSC_AI_BURST_DONE		AISS8AO8_IRQ_AI_BURST_DONE
#define	AISS8AO8_WAIT_GSC_AI_CLOCK			AISS8AO8_IRQ_AI_CLOCK
#define	AISS8AO8_WAIT_GSC_AO_CLOCK			AISS8AO8_IRQ_AO_CLOCK
#define	AISS8AO8_WAIT_GSC_DIO_0_L2H			AISS8AO8_IRQ_DIO_0_L2H
#define	AISS8AO8_WAIT_GSC_AO_THRESH_H2L		AISS8AO8_IRQ_AO_THRESH_H2L
#define	AISS8AO8_WAIT_GSC_AO_THRESH_L2H		AISS8AO8_IRQ_AO_THRESH_L2H
#define	AISS8AO8_WAIT_GSC_AO_LOAD_RDY_HL	AISS8AO8_IRQ_AO_LOAD_RDY_H2L
#define	AISS8AO8_WAIT_GSC_AO_LOAD_RDY_LH	AISS8AO8_IRQ_AO_LOAD_RDY_L2H
#define	AISS8AO8_WAIT_GSC_AO_BURST_READY	AISS8AO8_IRQ_AO_BURST_READY
#define	AISS8AO8_WAIT_GSC_AO_FAULT			AISS8AO8_IRQ_AO_FAULT
#define	AISS8AO8_WAIT_GSC_ALL				AISS8AO8_IRQ_ALL
// gsc_wait_t.alt flags
#define	AISS8AO8_WAIT_ALT_ALL				0x0000
// gsc_wait_t.io
#define	AISS8AO8_WAIT_IO_RX_ABORT			0x0001
#define	AISS8AO8_WAIT_IO_RX_DONE			0x0002
#define	AISS8AO8_WAIT_IO_RX_ERROR			0x0004
#define	AISS8AO8_WAIT_IO_RX_TIMEOUT			0x0008
#define	AISS8AO8_WAIT_IO_TX_ABORT			0x0010
#define	AISS8AO8_WAIT_IO_TX_DONE			0x0020
#define	AISS8AO8_WAIT_IO_TX_ERROR			0x0040
#define	AISS8AO8_WAIT_IO_TX_TIMEOUT			0x0080
#define	AISS8AO8_WAIT_IO_ALL				0x000FF

//*****************************************************************************
// AISS8AO8_IOCTL_WARP_MODE				BCR D30
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AISS8AO8_WARP_MODE_DISABLE		0
#define	AISS8AO8_WARP_MODE_ENABLE		1

//*****************************************************************************
// AISS8AO8_IOCTL_RX_IO_UNDERFLOW
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AISS8AO8_RX_IO_UNDERFLOW_DEFAULT	AISS8AO8_RX_IO_UNDERFLOW_CHECK
#define	AISS8AO8_RX_IO_UNDERFLOW_IGNORE		0
#define	AISS8AO8_RX_IO_UNDERFLOW_CHECK		1

//*****************************************************************************
// AISS8AO8_IOCTL_AI_BUF_UNDERFLOW			BCR D16
//
//	Parameter:	s32*
//		Pass in any valid option below, or
//		-1 to read the current setting.
#define	AISS8AO8_AI_BUF_UNDERFLOW_CLEAR		0
#define	AISS8AO8_AI_BUF_UNDERFLOW_TEST		(-1)

// For queries the following values are returned.
#define	AISS8AO8_AI_BUF_UNDERFLOW_NO		0
#define	AISS8AO8_AI_BUF_UNDERFLOW_YES		1



#endif
