// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/18AISS8AO8/18AISS8AO8_1.x_GSC_DN/driver/irq.c $
// $Rev: 44664 $
// $Date: 2019-04-04 16:02:51 -0500 (Thu, 04 Apr 2019) $

// 18AISS8AO8: Device Driver: source file

#include "main.h"



//*****************************************************************************
void dev_irq_isr_local_handler(dev_data_t* dev)
{
	u32	mask;
	u32	psr;

	psr		= os_reg_mem_rx_u32(NULL, dev->vaddr.gsc_psr_32);
	mask	= psr & (psr >> 16) & 0xFFFF;

	if (mask)
	{
		psr	= (psr & 0xFFFF) | ((mask << 16) ^ 0xFFFF0000);
		os_reg_mem_tx_u32(NULL, dev->vaddr.gsc_psr_32, psr);
		gsc_wait_resume_irq_gsc(dev, mask);
	}
	else
	{
		gsc_wait_resume_irq_main(dev, GSC_WAIT_MAIN_SPURIOUS);
	}
}



//*****************************************************************************
int dev_irq_create(dev_data_t* dev)
{
	int	ret;

	os_reg_mem_tx_u32(dev, dev->vaddr.gsc_psr_32, 0);
	ret	= gsc_irq_create(dev);
	return(ret);
}



//*****************************************************************************
void dev_irq_destroy(dev_data_t* dev)
{
	if (dev->vaddr.gsc_psr_32)
		os_reg_mem_tx_u32(dev, dev->vaddr.gsc_psr_32, 0);

	gsc_irq_destroy(dev);
}


