// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/18AISS8AO8/18AISS8AO8_1.x_GSC_DN/include/18aiss8ao8_utils.h $
// $Rev: 51966 $
// $Date: 2022-10-26 10:35:15 -0500 (Wed, 26 Oct 2022) $

// 18AISS8AO8: Utilities: header file

#ifndef	__18AISS8AO8_UTILS_H__
#define	__18AISS8AO8_UTILS_H__

#include "18aiss8ao8_api.h"
#include "gsc_utils.h"
#include "gsc_utils_pci.h"



// prototypes *****************************************************************

// API utility services

int	aiss8ao8_close_util			(int fd, int index, int verbose);
int aiss8ao8_init_util			(int verbose);
int aiss8ao8_ioctl_util			(int fd, int index, int verbose, int request, void* arg);
int	aiss8ao8_open_util			(int device, int share, int index, int verbose, int* fd);
int	aiss8ao8_read_util			(int fd, int index, int verbose, void* dst, size_t bytes);
int	aiss8ao8_write_util			(int fd, int index, int verbose, const void* src, size_t bytes);

// IOCTL utility services

int	aiss8ao8_ai_buf_clear		(int fd, int index, int verbose);								// AISS8AO8_IOCTL_AI_BUF_CLEAR
int	aiss8ao8_ai_buf_level		(int fd, int index, int verbose, s32* get);						// AISS8AO8_IOCTL_AI_BUF_LEVEL
int	aiss8ao8_ai_buf_overflow	(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_AI_BUF_OVERFLOW
int	aiss8ao8_ai_buf_thr_lvl		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_AI_BUF_THR_LVL
int	aiss8ao8_ai_buf_thr_sts		(int fd, int index, int verbose, s32* get);						// AISS8AO8_IOCTL_AI_BUF_THR_STS
int	aiss8ao8_ai_buf_underflow	(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_AI_BUF_UNDERFLOW
int	aiss8ao8_ai_burst_enable	(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_AI_BURST_ENABLE
int	aiss8ao8_ai_burst_size		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_AI_BURST_SIZE
int	aiss8ao8_ai_burst_status	(int fd, int index, int verbose, s32* get);						// AISS8AO8_IOCTL_AI_BURST_STATUS
int	aiss8ao8_ai_chan_sel		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_AI_CHAN_SEL
int	aiss8ao8_ai_clk_trig_out	(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_AI_CLK_TRIG_OUT
int	aiss8ao8_ai_clock_src		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_AI_CLOCK_SRC
int	aiss8ao8_ai_enable			(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_AI_ENABLE
int	aiss8ao8_ai_grp_a_filter	(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_AI_GRP_A_FILTER
int	aiss8ao8_ai_grp_b_filter	(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_AI_GRP_B_FILTER
int	aiss8ao8_ai_i_loop_term		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_AI_I_LOOP_TERM
int	aiss8ao8_ai_mode			(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_AI_MODE
int	aiss8ao8_ai_range			(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_AI_RANGE
int	aiss8ao8_ai_sw_clock		(int fd, int index, int verbose);								// AISS8AO8_IOCTL_AI_SW_CLOCK
int	aiss8ao8_ai_sw_trigger		(int fd, int index, int verbose);								// AISS8AO8_IOCTL_AI_SW_TRIGGER
int	aiss8ao8_ai_trig_src		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_AI_TRIG_SRC
int	aiss8ao8_ao_buf_clear		(int fd, int index, int verbose);								// AISS8AO8_IOCTL_AO_BUF_CLEAR
int	aiss8ao8_ao_buf_empty		(int fd, int index, int verbose, s32* get);						// AISS8AO8_IOCTL_AO_BUF_EMPTY
int	aiss8ao8_ao_buf_full		(int fd, int index, int verbose, s32* get);						// AISS8AO8_IOCTL_AO_BUF_FULL
int	aiss8ao8_ao_buf_level		(int fd, int index, int verbose, s32* get);						// AISS8AO8_IOCTL_AO_BUF_LEVEL
int	aiss8ao8_ao_buf_load_req	(int fd, int index, int verbose);								// AISS8AO8_IOCTL_AO_BUF_LOAD_REQ
int	aiss8ao8_ao_buf_load_sts	(int fd, int index, int verbose, s32* get);						// AISS8AO8_IOCTL_AO_BUF_LOAD_STS
int	aiss8ao8_ao_buf_mode		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_AO_BUF_MODE
int	aiss8ao8_ao_buf_over_data	(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_AO_BUF_OVER_DATA
int	aiss8ao8_ao_buf_over_fram	(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_AO_BUF_OVER_FRAM
int	aiss8ao8_ao_buf_thr_lvl		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_AO_BUF_THR_LVL
int	aiss8ao8_ao_buf_thr_sts		(int fd, int index, int verbose, s32* get);						// AISS8AO8_IOCTL_AO_BUF_THR_STS
int	aiss8ao8_ao_burst_enable	(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_AO_BURST_ENABLE
int	aiss8ao8_ao_burst_status	(int fd, int index, int verbose, s32* get);						// AISS8AO8_IOCTL_AO_BURST_STATUS
int	aiss8ao8_ao_chan_sel		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_AO_CHAN_SEL
int	aiss8ao8_ao_clk_trig_out	(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_AO_CLK_TRIG_OUT
int	aiss8ao8_ao_clock_ready		(int fd, int index, int verbose, s32* get);						// AISS8AO8_IOCTL_AO_CLOCK_READY
int	aiss8ao8_ao_clock_src		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_AO_CLOCK_SRC
int	aiss8ao8_ao_enable			(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_AO_ENABLE
int	aiss8ao8_ao_mode			(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_AO_MODE
int	aiss8ao8_ao_output_mode		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_AO_OUTPUT_MODE
int	aiss8ao8_ao_range			(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_AO_RANGE
int	aiss8ao8_ao_sw_clock		(int fd, int index, int verbose);								// AISS8AO8_IOCTL_AO_SW_CLOCK
int	aiss8ao8_ao_sw_trigger		(int fd, int index, int verbose);								// AISS8AO8_IOCTL_AO_SW_TRIGGER
int	aiss8ao8_ao_trig_src		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_AO_TRIG_SRC
int	aiss8ao8_auto_cal_sts		(int fd, int index, int verbose, s32* get);						// AISS8AO8_IOCTL_AUTO_CAL_STS
int	aiss8ao8_auto_calibrate		(int fd, int index, int verbose);								// AISS8AO8_IOCTL_AUTO_CALIBRATE
int	aiss8ao8_data_format		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_DATA_FORMAT
int	aiss8ao8_dio_dir_out		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_DIO_DIR_OUT
int	aiss8ao8_dio_read			(int fd, int index, int verbose, s32* get);						// AISS8AO8_IOCTL_DIO_READ
int	aiss8ao8_dio_write			(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_DIO_WRITE
int	aiss8ao8_gen_a_enable		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_GEN_A_ENABLE
int	aiss8ao8_gen_a_ndiv			(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_GEN_A_NDIV
int	aiss8ao8_gen_b_enable		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_GEN_B_ENABLE
int	aiss8ao8_gen_b_ndiv			(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_GEN_B_NDIV
int	aiss8ao8_gen_c_enable		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_GEN_C_ENABLE
int	aiss8ao8_gen_c_ndiv			(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_GEN_C_NDIV
int	aiss8ao8_gen_d_enable		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_GEN_D_ENABLE
int	aiss8ao8_gen_d_ndiv			(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_GEN_D_NDIV
int	aiss8ao8_initialize			(int fd, int index, int verbose);								// AISS8AO8_IOCTL_INITIALIZE
int	aiss8ao8_irq_enable			(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_IRQ_ENABLE
int	aiss8ao8_query				(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_QUERY
int	aiss8ao8_reg_mod			(int fd, int index, int verbose, u32 reg, u32 value, u32 mask);	// AISS8AO8_IOCTL_REG_MOD
int	aiss8ao8_reg_read			(int fd, int index, int verbose, u32 reg, u32* value);			// AISS8AO8_IOCTL_REG_READ
int	aiss8ao8_reg_write			(int fd, int index, int verbose, u32 reg, u32 value);			// AISS8AO8_IOCTL_REG_WRITE
int	aiss8ao8_rx_io_abort		(int fd, int index, int verbose, s32* get);						// AISS8AO8_IOCTL_RX_IO_ABORT
int	aiss8ao8_rx_io_mode			(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_RX_IO_MODE
int	aiss8ao8_rx_io_overflow		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_RX_IO_OVERFLOW
int	aiss8ao8_rx_io_timeout		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_RX_IO_TIMEOUT
int	aiss8ao8_tx_io_abort		(int fd, int index, int verbose, s32* get);						// AISS8AO8_IOCTL_TX_IO_ABORT
int	aiss8ao8_tx_io_mode			(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_TX_IO_MODE
int	aiss8ao8_tx_io_overflow		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_TX_IO_OVERFLOW
int	aiss8ao8_tx_io_timeout		(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_TX_IO_TIMEOUT
int	aiss8ao8_rx_io_underflow	(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_RX_IO_UNDERFLOW
int	aiss8ao8_wait_cancel		(int fd, int index, int verbose, gsc_wait_t* wait);				// AISS8AO8_IOCTL_WAIT_CANCEL
int	aiss8ao8_wait_event			(int fd, int index, int verbose, gsc_wait_t* wait);				// AISS8AO8_IOCTL_WAIT_EVENT
int	aiss8ao8_wait_status		(int fd, int index, int verbose, gsc_wait_t* wait);				// AISS8AO8_IOCTL_WAIT_STATUS
int	aiss8ao8_warp_mode			(int fd, int index, int verbose, s32 set, s32* get);			// AISS8AO8_IOCTL_WARP_MODE

// Auxiliary utility services

int	aiss8ao8_config_ai			(int fd, int index, int verbose, s32 fsamp);
int	aiss8ao8_config_ao			(int fd, int index, int verbose, s32 fsamp);
int	aiss8ao8_count_boards		(int verbose, s32* get);
int	aiss8ao8_fsamp_ai_compute	(int fd, int index, int verbose, s32 fsamp, s32* ndiv, s32* warp, double* rate);
int	aiss8ao8_fsamp_ai_report	(int fd, int index, int verbose, int chan, s32* fsamp);
int	aiss8ao8_fsamp_ai_report_all(int fd, int index, int verbose, s32* fsamp);
int	aiss8ao8_fsamp_ao_compute	(int fd, int index, int verbose, s32 fsamp, s32* ndiv, double* rate);
int	aiss8ao8_fsamp_ao_report	(int fd, int index, int verbose, int chan, s32* fsamp);
int	aiss8ao8_fsamp_ao_report_all(int fd, int index, int verbose, s32* fsamp);
int	aiss8ao8_id_device			(int fd, int index, int verbose);
int	aiss8ao8_reg_list			(int fd, int detail);

const gsc_reg_def_t*			aiss8ao8_reg_get_def_id		(u32 reg);
const gsc_reg_def_t*			aiss8ao8_reg_get_def_index	(int index);
const char*						aiss8ao8_reg_get_desc		(u32 reg);
const char*						aiss8ao8_reg_get_name		(u32 reg);



#endif
