// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/18AISS8AO8/18AISS8AO8_1.x_GSC_DN/samples/fsamp/perform.c $
// $Rev: 52604 $
// $Date: 2023-03-10 14:41:45 -0600 (Fri, 10 Mar 2023) $

// 18AISS8AO8: Sample Application: source file

#include "main.h"



// macros *********************************************************************

#define	FILE_NAME				"fsamp.txt"



//*****************************************************************************
int perform_tests(const args_t* args)
{
	int		errs	= 0;
	FILE*	file	= NULL;
	s32		fsamp;
	s32		max		= 0;
	s32		min		= 0;
	s32		ndiv;
	double	rate;
	s32		warp;

	gsc_label("Fsamp Computation");
	printf("\n");
	gsc_label_level_inc();

	if (args->range == 0)
	{
		min		= args->fsamp;
		max		= args->fsamp;
	}
	else
	{
		errs	+= aiss8ao8_query(args->fd, -1, 0, AISS8AO8_QUERY_FSAMP_MAX, &max);
		errs	+= aiss8ao8_query(args->fd, -1, 0, AISS8AO8_QUERY_FSAMP_MIN, &min);
	}

	if (args->save)
	{
		file	= fopen(FILE_NAME, "w+b");

		if (file == NULL)
		{
			printf("FAIL <---  (unable to create %s)\n", FILE_NAME);
			errs	= 1;
		}
		else
		{
			fprintf(file, "# 18AISS8AO8 Scan Rates\n");
			fprintf(file, "# Request   Produced\n");
			fprintf(file, "# ========  =============\n");
		}
	}

	for (fsamp = min; fsamp <= max; fsamp++)
	{
		errs	+= aiss8ao8_fsamp_ai_compute(args->fd, -1, 1, fsamp, &ndiv, &warp, &rate);

		if (file)
			fprintf(file, "%10ld  %13.6f\n", (long) fsamp, (double) rate);
	}

	if (file)
		fclose(file);

	gsc_label_level_dec();
	return(errs);
}


