// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/18AISS8AO8/18AISS8AO8_1.x_GSC_DN/utils/ai_chan_sel.c $
// $Rev: 50404 $
// $Date: 2022-02-16 16:57:40 -0600 (Wed, 16 Feb 2022) $

// 18AISS8AO8: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	aiss8ao8_ai_chan_sel
*
*	Purpose:
*
*		Provide a visual wrapper for the AISS8AO8_IOCTL_AI_CHAN_SEL service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		set		This is the value to apply.
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int	aiss8ao8_ai_chan_sel(int fd, int index, int verbose, s32 set, s32* get)
{
	int	errs	= 0;
	s32	qty		= 0;
	int	ret;

	if (verbose)
		gsc_label_index("AI Channel Select", index);

	errs	+= aiss8ao8_query(fd, -1, 0, AISS8AO8_QUERY_CHANNEL_AI_QTY, &qty);
	set		&= (qty == 4) ? 0xF : 0xFF;
	ret		= aiss8ao8_ioctl(fd, AISS8AO8_IOCTL_AI_CHAN_SEL, &set);
	errs	+= ret ? 1 : 0;

	if (verbose)
		printf("%s  (0x%lX)\n", errs ? "FAIL <---" : "PASS", (long) set);

	if (get)
		get[0]	= set;

	return(errs);
}


