// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/18AISS8AO8/18AISS8AO8_1.x_GSC_DN/utils/ao_buf_load_req.c $
// $Rev: 50404 $
// $Date: 2022-02-16 16:57:40 -0600 (Wed, 16 Feb 2022) $

// 18AISS8AO8: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	aiss8ao8_ao_buf_load_req
*
*	Purpose:
*
*		Provide a visual wrapper for the AISS8AO8_IOCTL_AO_BUF_LOAD_REQ service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int	aiss8ao8_ao_buf_load_req(int fd, int index, int verbose)
{
	int	errs;
	int	ret;

	if (verbose)
		gsc_label_index("AO Buffer Load Request", index);

	ret		= aiss8ao8_ioctl(fd, AISS8AO8_IOCTL_AO_BUF_LOAD_REQ, NULL);
	errs	= ret ? 1 : 0;

	if (verbose)
		printf("%s\n", errs ? "FAIL <---" : "PASS");

	return(errs);
}


