// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/18AISS8AO8/18AISS8AO8_1.x_GSC_DN/utils/rx_io_underflow.c $
// $Rev: 46041 $
// $Date: 2019-08-13 15:23:10 -0500 (Tue, 13 Aug 2019) $

// 18AISS8AO8: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	aiss8ao8_rx_io_underflow
*
*	Purpose:
*
*		Provide a visual wrapper for the AISS8AO8_IOCTL_RX_IO_UNDERFLOW service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		set		This is the value to apply.
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int	aiss8ao8_rx_io_underflow(int fd, int index, int verbose, s32 set, s32* get)
{
	char		buf[128];
	int			errs;
	const char*	ptr		= buf;
	int			ret;

	if (verbose)
		gsc_label_index("Rx I/O Underflow", index);

	ret		= aiss8ao8_ioctl(fd, AISS8AO8_IOCTL_RX_IO_UNDERFLOW, &set);
	errs	= ret ? 1 : 0;

	switch (set)
	{
		default:

			errs++;
			sprintf(buf, "Unrecognized option: 0x%lX", (long) set);
			break;

		case -1:

			ptr	= "Feature Not Supported";
			break;

		case AISS8AO8_RX_IO_UNDERFLOW_IGNORE:

			ptr	= "Ignore";
			break;

		case AISS8AO8_RX_IO_UNDERFLOW_CHECK:

			ptr	= "Check";
			break;
	}

	if (verbose)
		printf("%s  (%s)\n", errs ? "FAIL <---" : "PASS", ptr);

	if (get)
		get[0]	= set;

	return(errs);
}


